import 'package:feed_plugin/models/media.dart';
import 'package:feed_plugin/utilities/social_media.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_signin_button/button_list.dart';
import 'package:flutter_signin_button/button_view.dart';

class MediaPage extends StatefulWidget {
  const MediaPage({
    Key key,
    this.whatsapp,
    this.facebook,
    this.instagram,
    this.twitter,
    this.linkedin,
    this.youtube,
    this.tiktok,
  }) : super(key: key);

  final String whatsapp;
  final String facebook;
  final String instagram;
  final String twitter;
  final String linkedin;
  final String youtube;
  final String tiktok;

  @override
  _MediaPageState createState() => _MediaPageState();
}

class _MediaPageState extends State<MediaPage> {
  List<String> row1;
  List<String> row2;

  List<String> socialMediaName;
  List<String> socialMediaUrl;
  List<String> socialMediaImg;

  initSocialMedia() async {
    var mediaData = this.widget;
    socialMediaUrl = [
      mediaData.whatsapp,
      mediaData.facebook,
      mediaData.instagram,
      mediaData.twitter,
      mediaData.linkedin,
      mediaData.youtube,
      mediaData.tiktok,
    ];
    socialMediaName = [
      "whatsapp",
      "facebook",
      "instagram",
      "twitter",
      "linkedin",
      "youtube",
      "tiktok",
    ];
    socialMediaImg = [
      whatsapp,
      facebook,
      instagram,
      twitter,
      linkedin,
      youtube,
      tiktok,
    ];

    List<String> img = socialMediaImg;
    List<String> name = socialMediaName;
    List<String> url = socialMediaUrl;

    socialMediaImg = [];
    socialMediaUrl = [];
    socialMediaUrl = [];

    for (var i = 0; i < 7; i++) {
      if (url[i] != null && url[i] != "false") {
        socialMediaImg.add(img[i]);
        socialMediaName.add(name[i]);
        socialMediaUrl.add(url[i]);
      }
    }
  }

  _gagv() {
    List<Widget> children1 = [];
    List<Widget> children2 = [];

    for (var i = 0; i < socialMediaUrl.length; i++) {
      if (i < 4 && row1.length < 4 && row1.length < socialMediaImg.length) {
        row1.add(socialMediaImg[i]);
      } else if (row2.length < 3 && row2.length < socialMediaImg.length - 4) {
        row2.add(socialMediaImg[i]);
      }
    }

    for (var i = 0; i < row1.length; i++) {
      var e = Expanded(
          child: Column(children: [
        SizedBox(
            width: ScreenUtil().setHeight(25),
            height: ScreenUtil().setHeight(25),
            child: Image.network(row1[i])),
        Text(socialMediaName[i])
      ]));
      children1.add(e);
    }
    if (row2.length > 0) {
      for (var i = 0; i < 4; i++) {
        var e = Expanded(
          child: Padding(
            padding: EdgeInsets.only(top: ScreenUtil().setHeight(10)),
            child: Column(
              children: [
                SizedBox(
                    width: ScreenUtil().setHeight(25),
                    height: ScreenUtil().setHeight(25),
                    child: row2.length - 1 >= i
                        ? Image.network(row2[i])
                        : Image.network(
                            row2[0],
                            color: Colors.white,
                          )),
                row2.length - 1 >= i ? Text(socialMediaName[4 + i]) : Text("")
              ],
            ),
          ),
        );
        children2.add(e);
      }
    }
    return Column(
        children: [Row(children: children1), Row(children: children2)]);
  }

  @override
  void initState() {
    super.initState();
    row1 = [];
    row2 = [];
    initSocialMedia();
  }

  @override
  Widget build(BuildContext context) {
    void _showButtonPressDialog(BuildContext context, String provider) {
      // Scaffold.of(context).showSnackBar(SnackBar(
      // content: Text('$provider Button Pressed!'),
      // backgroundColor: Colors.black26,
      // duration: Duration(milliseconds: 400),
      //   ));
    }
    return Container(
      margin: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
      color: Colors.white,
      height: ScreenUtil().setHeight(115),
      child: Padding(
          padding: EdgeInsets.only(top: ScreenUtil().setHeight(12)),
          child: _gagv()
          // Row(children: [
          //   Expanded(
          //       child: Row(children: [
          //   for (var i = 0; i < 2; i++) {
          //     Expanded(child: Image.network(youtube),)
          // }
          // ])
          // Column(children: <Widget>[
          //     Container(
          //         child: ClipOval(
          //             child: Image.
          //                 // network('youtube-round-color.png')
          //                 asset('assets/youtube-round-color.png')
          // Material(
          //     color: Color(0xFF37DB56),
          //     child: InkWell(
          //         splashColor: Color(0xFFFCA64F),
          //         child: SizedBox(
          //           width: ScreenUtil().setHeight(25),
          //           height: ScreenUtil().setHeight(25),
          //           child: Image.asset(
          //               'assets/images/youtube-round-color.png',
          //               scale: ScreenUtil().setWidth(1.3)),
          //           // new Image.asset(
          //           //   'assets/images/whatsapp-round-color.jpg',
          //           //   // scale: ScreenUtil().setWidth(1.3)
          //           // ),
          //         )))
          // )
          //             ),
          //     Padding(
          //       padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //       child: Container(
          //         child: Text(
          //           "Whatsapp",
          //           style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //         ),
          //       ),
          //     )
          //   ])
          // : Container(
          //     height: ScreenUtil().setHeight(30),
          //     padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //   ),
          //   Padding(
          //     padding: EdgeInsets.only(top: ScreenUtil().setHeight(15)),
          //     child: Column(children: <Widget>[
          //       Container(
          //         child: ClipOval(
          //             child: Material(
          //                 color: Color(0xFF007BB5),
          //                 child: InkWell(
          //                     splashColor: Color(0xFFFCA64F),
          //                     child: SizedBox(
          //                         width: ScreenUtil().setHeight(25),
          //                         height: ScreenUtil().setHeight(25),
          //                         child: SignInButton(
          //                           Buttons.LinkedIn,
          //                           mini: true,
          //                           onPressed: () {
          //                             _showButtonPressDialog(
          //                                 context, 'LinkedIn (mini)');
          //                           },
          //                         ))))),
          //       ),
          //       Padding(
          //         padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //         child: Container(
          //           child: Text(
          //             "Linkedin",
          //             style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //           ),
          //         ),
          //       )
          //     ]),
          //   )
          // ])),
          // Expanded(
          //     child: Column(children: [
          //   Column(children: <Widget>[
          //     Container(
          //       child: ClipOval(
          //           child: Material(
          //               color: Color(0xFF395185),
          //               child: InkWell(
          //                   splashColor: Color(0xFFFCA64F),
          //                   child: SizedBox(
          //                       width: ScreenUtil().setHeight(25),
          //                       height: ScreenUtil().setHeight(25),
          //                       child: SignInButton(
          //                         Buttons.Facebook,
          //                         mini: true,
          //                         onPressed: () {
          //                           _showButtonPressDialog(
          //                               context, 'Facebook (mini)');
          //                         },
          //                       ))))),
          //     ),
          //     Padding(
          //       padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //       child: Container(
          //         child: Text(
          //           "Facebook",
          //           style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //         ),
          //       ),
          //     )
          //   ]),
          //   Padding(
          //     padding: EdgeInsets.only(top: ScreenUtil().setHeight(15)),
          //     child: Column(children: <Widget>[
          //       Container(
          //         child: ClipOval(
          //             child: Material(
          //                 color: Colors.red,
          //                 child: InkWell(
          //                     splashColor: Color(0xFFFCA64F),
          //                     child: SizedBox(
          //                       width: ScreenUtil().setHeight(25),
          //                       height: ScreenUtil().setHeight(25),
          //                       child: Icon(
          //                         Icons.arrow_right,
          //                         color: Colors.white,
          //                         size: 35,
          //                       ),
          //                     )))),
          //       ),
          //       Padding(
          //         padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //         child: Container(
          //           child: Text(
          //             "Youtube",
          //             style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //           ),
          //         ),
          //       )
          //     ]),
          //   ),
          // ])),
          // Expanded(
          //     child: Column(children: [
          //   Column(children: <Widget>[
          //     Image.asset("assets/instegram.png",
          //         width: ScreenUtil().setHeight(25),
          //         height: ScreenUtil().setHeight(25),
          //         fit: BoxFit.fill),
          //     Padding(
          //       padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //       child: Container(
          //         child: Text(
          //           "Instagram",
          //           style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //         ),
          //       ),
          //     )
          //   ]),
          //   Padding(
          //     padding: EdgeInsets.only(top: ScreenUtil().setHeight(15)),
          //     child: Column(children: <Widget>[
          //       Container(
          //           child: ClipOval(
          //               child: Material(
          //                   color: Colors.black,
          //                   child: InkWell(
          //                       splashColor: Color(0xFFFCA64F),
          //                       child: SizedBox(
          //                           width: ScreenUtil().setHeight(25),
          //                           height: ScreenUtil().setHeight(25),
          //                           child: Image.asset(
          //                               "assets/images/tiktok.png",
          //                               scale: ScreenUtil().setWidth(0.6))))))),
          //     ]),
          //   ),
          //   Padding(
          //     padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //     child: Container(
          //       child: Text(
          //         "TikTok",
          //         style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //       ),
          //     ),
          //   )
          // ])),
          // Expanded(
          //     child: Column(children: [
          //   Column(children: <Widget>[
          //     Container(
          //       child: ClipOval(
          //           child: Material(
          //               color: Color(0xFF69ACE0),
          //               child: InkWell(
          //                   splashColor: Color(0xFFFCA64F),
          //                   child: SizedBox(
          //                       width: ScreenUtil().setHeight(25),
          //                       height: ScreenUtil().setHeight(25),
          //                       child: SignInButton(
          //                         Buttons.Twitter,
          //                         mini: true,
          //                         onPressed: () {
          //                           _showButtonPressDialog(
          //                               context, 'Twitter (mini)');
          //                         },
          //                       ))))),
          //     ),
          //     Padding(
          //       padding: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
          //       child: Container(
          //         child: Text(
          //           "Twitter",
          //           style: TextStyle(fontSize: 12, fontFamily: "Rubik"),
          //         ),
          //       ),
          //     )
          //   ])
          // ])),
          // ]),
          ),
    );
  }
}
